
//xsetaseta@gmail.com
//comSeta prueba
//Lector de sensor de temperatura externa Modelo KNEISSEL
//


#include <avr/io.h>
#include <avr/interrupt.h>

#define IN_READ 2

unsigned long time,timeU,timeInicio,diferencia;
bool inicio;
int dato;
bool estadoDato;

int canal;
int grados;
int decimales;
int humedad;
int control;
int NumBit;
int zgrados;

unsigned long DatoSalida;
unsigned char DatoSalida1;

char Stemporal[100];



void setup(void)
{
  Serial.begin(9600);
  Serial.println("Int433T3v2");
  pinMode(2, INPUT);
  pinMode(IN_READ, INPUT);

  cli();                // Disable INT
  EIMSK |= (1 << INT0);  // Enable external interrupt INT0
  EICRA |= (1 << ISC01); // Trigger INT0 on Change  en bajada
  sei();
}


void loop(void)
{
  if(estadoDato==1)
   {
     
     estadoDato=0;
     if(dato==255)
       { 
        DatoSalida1=0;
        DatoSalida=0;
        NumBit=0;        
        goto salto2;
       }     
    if(dato==3) 
      {
    //  Serial.println(DatoSalida,BIN);
    //  Serial.println(NumBit);
      
      canal = (DatoSalida & 0x400000)>>22;
      decimales=DatoSalida & 0x00000f;
      grados= (DatoSalida & 0x00FF00)>>8;
      
      if(grados&128)  grados=128-grados;               
      control=(DatoSalida & 0xFF0000)>>16;
      
      // sprintf(Stemporal,"Canal,%d,Grados,%d,Deci,%d,Control,%d,Bits,%d",canal,grados,decimales,control,NumBit);        
       sprintf(Stemporal,"%d,%d,%d,%d,%d",canal,grados,decimales,control,NumBit);        
       Serial.println(Stemporal);
       NumBit=0;
       goto salto2; 
      }
    if(DatoSalida & 0x80000000) DatoSalida1 |=1;
    DatoSalida1<<=1;
    DatoSalida<<=1;
    if(dato==1) DatoSalida|=1;
    NumBit++;
    
   }
   
salto2:
    ;
}


ISR(INT0_vect)
{
  time=micros();         
  diferencia=time-timeU;
  if (diferencia>1950 && diferencia<9900)
  {   
     
    if(diferencia>1950 && diferencia<2500)  //0
    {
      estadoDato=1;   dato=0;
      goto salto;
    }
    if(diferencia>4000 && diferencia<5050)  //1
    {             
      estadoDato=1;   dato=1;
      goto salto;
    }
    if(diferencia>8000 && diferencia<9000)  //empieza
    {
      estadoDato=1;   dato=3;
      goto salto;
    }
  }
  else
  {
    estadoDato=1; 
    dato=255; 
  }

salto: 
  timeU=time; 
}


